#
# lxc: linux Container library
#
# (C) Copyright IBM Corp. 2007, 2008
#
# Authors:
# Daniel Lezcano <daniel.lezcano at free.fr>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

Name: lxc
Version: 0.9.0
Release: 2.0.5%{?dist}
URL: http://lxc.sourceforge.net
Source: http://dl.sourceforge.net/sourceforge/%{name}/%{name}-%{version}.tar.gz
Summary: %{name} : Linux Container
Group: Applications/System
License: LGPL
BuildRoot: %{_tmppath}/%{name}-%{version}-build
Requires: libcap libvirt openssl rsync
# Sparc has nothing to be backwardly compatable with
%ifnarch %{sparc}
Requires: compat-db43
%endif
BuildRequires: libcap libcap-devel docbook-utils automake autoconf

Patch0001: 0010-lxc.functions-don-t-let-LXC_PATH-line-end-in-failure.patch
Patch0002: 0011-debian-template-set-arch-when-dpkg-doesn-t-exist-on-.patch
Patch0003: 0012-oracle-template-install-additional-user-specified-pk.patch
Patch0004: 0013-Fix-up-struct-lxc_container-locking.patch
Patch0005: 0015-lxclock-fix-coverity-found-leak.patch
Patch0006: 0020-af_unix.c-fix-coverity-found-bug-pass-addr-size.patch
Patch0007: 0025-lxcccontainer-add-missing-va_end-found-by-coverity.patch
Patch0008: 0030-lxccontaienr-fix-missing-va_end-in-error-case.patch
Patch0009: 0035-lxc_monitor-make-sure-msg.name-is-null-terminated-bu.patch
Patch0010: 0040-lxcapi_create-fix-leak-of-tpath-when-a-container-alr.patch
Patch0011: 0045-genl.c-fix-a-resource-leak-found-by-coverity.patch
Patch0012: 0050-fix-resource-leak-of-utsname-in-error-path-found-by-.patch
Patch0013: 0055-fix-resource-leak-of-netdev-on-error-path-found-by-c.patch
Patch0014: 0060-fix-free-of-alloca-d-buffer-found-by-coverity.patch
Patch0015: 0065-fix-coverity-found-resource-leaks-in-config_network_.patch
Patch0016: 0070-fix-coverity-found-resource-leaks-on-error-paths.patch
Patch0017: 0075-coverity-resource-leak-fixes.patch
Patch0018: 0080-fix-coverity-found-errors.patch
Patch0019: 0085-fix-lxc-attach-usage.patch
Patch0020: 0090-fortify-check-the-value-returned-from-write-2.patch
Patch0021: 0095-fortify-minor-cleanups-for-unused-variables-stricter.patch
Patch0022: 0100-fortify-use-reentrant-safe-strtok_r.patch
Patch0023: 0105-fix-checking-hook-script-exit-code.patch
Patch0024: 0110-quiet-gcc-4.4.7-warning-about-saveptr-use-before-ini.patch
Patch0025: 0115-make-lxc_af_unix_open-safely-return-error-on-long-pa.patch
Patch0026: 0120-cgpath-test-don-t-check-path-len-before-checking-if-.patch
Patch0027: 0125-remove-needless-check-for-line-which-cannot-be-NULl-.patch
Patch0028: 0130-goto-correct-cleanup-label-to-ensure-fd-is-closed.patch
Patch0029: 0131-fix-building-docs.patch
Patch0030: 0135-add-free-conf-rcfile-in-lxc_conf_free.patch
Patch0031: 0140-lxc_start-free-the-conf-if-starting-the-container-fa.patch
Patch0032: 0145-coverity-fix-leak-in-error-case.patch
Patch0033: 0150-coverity-fix-leak-when-ipv6-gw-is-auto.patch
Patch0034: 0155-confile.c-config_network_ipv6_gateway-only-define-gw.patch
Patch0035: 0160-coverity-fix-dereference-before-NULL-check.patch
Patch0036: 0165-coverity-fix-dereference-NULL-return-value.patch
Patch0037: 0170-coverity-fix-potential-dereference-NULL-returned-fro.patch
Patch0038: 0175-conf.c-remove-a-break.patch
Patch0039: 0200-oracle-template-mount-dev-shm-as-tmpfs.patch
Patch0040: 0205-fix-sshd-template.patch
Patch0041: 0210-add-clonehostname-hook.patch
Patch0042: 0220-oracle-template-add-openssh-clients-to-enable-scp-in.patch
Patch0043: 0225-oracle-template-fix-selinux-context-on-symlinks-in-d.patch

%define with_python %{?_with_python: 1} %{?!_with_python: 0}
%if %{with_python}
Requires: python3
BuildRequires: python3-devel
%endif

%define with_lua %{?_with_lua: 1} %{?!_with_lua: 0}
%if %{with_lua}
Requires: lua-filesystem
BuildRequires: lua-devel
%endif

%description

The package "%{name}" provides the command lines to create and manage
containers.  It contains a full featured container with the isolation
/ virtualization of the pids, the ipc, the utsname, the mount points,
/proc, /sys, the network and it takes into account the control groups.
It is very light, flexible, and provides a set of tools around the
container like the monitoring with asynchronous events notification,
or the freeze of the container. This package is useful to create
Virtual Private Server, or to run isolated applications like bash or
sshd.

%package        libs
Summary:        runtime library files for %{name}
Group:          System Environment/Libraries

%description    libs
The %{name}-libs package contains libraries for running %{name} applications.

%package devel
Summary: development library for %{name}
Group: Development/Libraries

%description devel
The %{name}-devel package contains header files and library needed for
development of the linux containers.

%prep
%setup
%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1
%patch0020 -p1
%patch0021 -p1
%patch0022 -p1
%patch0023 -p1
%patch0024 -p1
%patch0025 -p1
%patch0026 -p1
%patch0027 -p1
%patch0028 -p1
%patch0029 -p1
%patch0030 -p1
%patch0031 -p1
%patch0032 -p1
%patch0033 -p1
%patch0034 -p1
%patch0035 -p1
%patch0036 -p1
%patch0037 -p1
%patch0038 -p1
%patch0039 -p1
%patch0040 -p1
%patch0041 -p1
%patch0042 -p1
%patch0043 -p1
%build
PATH=$PATH:/usr/sbin:/sbin %configure $args \
%if %{with_lua}
  --enable-lua \
%endif
%if %{with_python}
  --enable-python \
%endif
  --disable-rpath \
  --disable-apparmor \
  --with-config-path=/container

make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot}
find %{buildroot} -type f -name '*.la' -exec rm -f {} ';'

%clean
rm -rf %{buildroot}

%post

%files
%defattr(-,root,root)
%{_bindir}/*
%attr(4111,root,root) %{_bindir}/lxc-attach
%attr(4111,root,root) %{_bindir}/lxc-create
%attr(4111,root,root) %{_bindir}/lxc-clone
%attr(4111,root,root) %{_bindir}/lxc-shutdown
%attr(4111,root,root) %{_bindir}/lxc-start
%attr(4111,root,root) %{_bindir}/lxc-netstat
%attr(4111,root,root) %{_bindir}/lxc-unshare
%attr(4111,root,root) %{_bindir}/lxc-execute
%attr(4111,root,root) %{_bindir}/lxc-checkpoint
%attr(4111,root,root) %{_bindir}/lxc-restart
%{_mandir}/*
%{_datadir}/doc/*
%{_datadir}/lxc/*
%{_sysconfdir}/lxc/*

%files libs
%defattr(-,root,root)
%{_libdir}/*.so.*
%{_libdir}/%{name}
%if %{with_lua}
%{_datadir}/lua
%{_libdir}/lua
%endif
%if %{with_python}
%{_libdir}/python*
%endif
%{_localstatedir}/*
%attr(4555,root,root) %{_libexecdir}/%{name}/lxc-init

%files devel
%defattr(-,root,root)
%{_includedir}/%{name}/*
%{_libdir}/*.so
%{_libdir}/pkgconfig/*

%changelog
* Thu Oct 17 2013 Dwight Engen <dwight.engen@oracle.com> - Version 0.9.0-2.0.5
- fix ssh into container with SELinux enabled on host
- fix scp into container by installing openssh-clients by default

* Fri Jul 12 2013 Dwight Engen <dwight.engen@oracle.com> - Version 0.9.0-2.0.4
- orabug 16316936 fix sem_open(3) by mounting /dev/shm as tmpfs
- orabug 17042712 fix sshd template
- orabug 17066749 fix hostname in cloned containers

* Thu May  9 2013 Dwight Engen <dwight.engen@oracle.com> - Version 0.9.0-2.0.3
- applied upstream fixes
- oracle build environment for lxc now has newer kernel-headers, which makes
  lxc-attach now work since at build time the the setns syscall introduced
  in kernel 3.7 will be found

* Fri Apr 12 2013 Dwight Engen <dwight.engen@oracle.com> - Version 0.9.0-2.0.2
- applied upstream patches for other minor issues
- orabug 16656944 lxc-clone fails
- The sparc architecture doesn't have or need a compat-db4* requirement
  in the spec-file

* Mon Apr 08 2013 Dwight Engen <dwight.engen@oracle.com> - Version 0.9.0-2.0.1
- update to upstream 0.9.0
- lxc.spec: remove patches that have been upstreamed
- patch back to building docs with docbook-utils instead of docbook2X

* Tue Mar 12 2013 Dwight Engen <dwight.engen@oracle.com> - Version 0.8.0-2.0.9
- move .rpmdb on Debian host
- orabug 16327664 fix cosmetic error on ol5 cp resolv.conf
- orabug 16297950 silence cosmetic "cat /proc/self/attr/current" error

* Thu Feb 14 2013 Dwight Engen <dwight.engen@oracle.com> - Version 0.8.0-2.0.8
- orabug 16324116 handle 5.latest correctly in redo_pkgs
- orabug 16327382 commenting out of "Remounting rootfs" in rc.sysinit

* Wed Feb 13 2013 Dwight Engen <dwight.engen@oracle.com> - Version 0.8.0-2.0.7
- use libvirt for rpm Requires not libvirt-daemon

* Tue Feb 12 2013 Dwight Engen <dwight.engen@oracle.com> - Version 0.8.0-2.0.6
- orabug 16297177 default to same release as host
- orabug 16297404 add libvirt-daemon and compat-db43 as rpm Requires
- orabug 16297950 set selinux labels on devices created by oracle template
- orabug 16302675 don't attempt to remount / (superficial error message)
- orabug 16303282 don't attempt to unmount swap in container halt
- orabug 16304447 bad copy when using oracle templatefs -t option
- orabug 16316699 lxc-ls returning non-container directories

* Fri Feb 08 2013 Dwight Engen <dwight.engen@oracle.com> - Version 0.8.0-2.0.5
- merge all oracle template patches into one, update to latest to handle
  ol4 better and handle some selinux cases
- fix orabug 16296667 due to misapplied patch in lxc-shutdown
- remove distro config /etc/lxc/lxc.conf patch since it is not needed and
  the name is changing in 0.9.0

* Wed Jan 09 2013 Dwight Engen <dwight.engen@oracle.com> - Version 0.8.0-2.0.4
- fix orabug 16010534 prevent insmod, rmmod (git d378aebe)
- fix orabug 16071473 document <Ctrl-a q> to escape lxc-console (git 76848789)
- fix orabug 16090880 lxc-shutdown not working

* Fri Dec 28 2012 Dwight Engen <dwight.engen@oracle.com> - Version 0.8.0-2.0.3
- add fixes for orabugs 15984742, 15989848
- fix creation of busybox based containers

* Fri Dec 14 2012 Dwight Engen <dwight.engen@oracle.com> - Version 0.8.0-2.0.2
- add fixes for orabugs 15984921, 15972116, use with OVM template rootfs
- add support for creating ol4 container from ovm template

* Tue Dec  4 2012 Dwight Engen <dwight.engen@oracle.com> - Version 0.8.0-2.0.1
- Add autoconf, automake to BuildRequires since patch0001 modifies configure.ac,
  and if the build files are not regenerated the Oracle template will not be
  included.
  
* Wed Nov 21 2012 Dwight Engen <dwight.engen@oracle.com> - Version 0.8.0-2
- include oracle template
- set container directory to /container

* Mon Sep 10 2012 Dwight Engen <dwight.engen@oracle.com> - Version 0.8.0
- fix lxc-init moved to libexec
- .pc moved to _libdir
- package template files /usr/share/lxc/templates

* Thu Sep  8 2011 Greg Kurz <gkurz@fr.ibm.com> - Version 0.7.5.1
- fix installed files for rpmbuild
- introduce lxc-libs package

* Fri Jul 23 2010 Daniel Lezcano <dlezcano@fr.ibm.com> - Version 0.7.2
- set attribute for installed files
- fix libraries installation

* Mon Mar 24 2009 Daniel Lezcano <daniel.lezcano@free.fr> - Version 0.6.1
- Removed capability setting, let the user to do that through "lxc-setcap"

* Mon Feb 16 2009 Daniel Lezcano <daniel.lezcano@free.fr> - Version 0.6.0
- Added more capabilities to the executables

* Sun Jan 25 2009 Daniel Lezcano <daniel.lezcano@free.fr> - Version 0.6.0
- Reduced spec file

* Sun Aug 3 2008 Daniel Lezcano <dlezcano@fr.ibm.com> - Version 0.1.0
- Initial RPM release.

# Local variables:
# mode: shell-script
# sh-shell: rpm
# end:
